Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxinit.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxinit.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxinit.c
@@ -49,19 +49,35 @@
 #include "dmxscrinit.h"
 #include "dmxcursor.h"
 #include "dmxfont.h"
-#include "config/dmxconfig.h"
 #include "dmxcb.h"
 #include "dmxprop.h"
 #include "dmxstat.h"
+#include "dmxlaunch.h"
+#include "dmxgrab.h"
+#include "dmxselection.h"
+#include "dmxshm.h"
 #ifdef RENDER
 #include "dmxpict.h"
 #endif
+#ifdef COMPOSITE
+#include "dmxcomp.h"
+#endif
+#include "dmxextension.h"
 
 #include <X11/Xos.h>                /* For gettimeofday */
 #include "dixstruct.h"
+#include "opaque.h"
 #include "panoramiXsrv.h"
 
+#ifdef HAVE_SHA1_IN_LIBMD /* Use libmd for SHA1 */
+# include <sha1.h>
+#else /* Use OpenSSL's libcrypto */
+# include <stddef.h>  /* buggy openssl/sha.h wants size_t */
+# include <openssl/sha.h>
+#endif
+
 #include <signal.h>             /* For SIGQUIT */
+#include <execinfo.h>
 
 #ifdef GLXEXT
 #include <GL/glx.h>
@@ -81,21 +97,16 @@ extern void GlxSetVisualConfigs(
 int             dmxNumScreens;
 DMXScreenInfo  *dmxScreens;
 
-int             dmxNumInputs;
-DMXInputInfo   *dmxInputs;
-
-int             dmxShadowFB = FALSE;
-
 XErrorEvent     dmxLastErrorEvent;
 Bool            dmxErrorOccurred = FALSE;
 
 char           *dmxFontPath = NULL;
 
-Bool            dmxOffScreenOpt = TRUE;
+Bool            dmxOffScreenOpt = FALSE;
 
 Bool            dmxSubdividePrimitives = TRUE;
 
-Bool            dmxLazyWindowCreation = TRUE;
+Bool            dmxLazyWindowCreation = FALSE;
 
 Bool            dmxUseXKB = TRUE;
 
@@ -104,7 +115,7 @@ int             dmxDepth = 0;
 #ifndef GLXEXT
 static Bool     dmxGLXProxy = FALSE;
 #else
-Bool            dmxGLXProxy = TRUE;
+Bool            dmxGLXProxy = FALSE;
 
 Bool            dmxGLXSwapGroupSupport = TRUE;
 
@@ -115,7 +126,61 @@ Bool            dmxGLXFinishSwap = FALSE
 
 Bool            dmxIgnoreBadFontPaths = FALSE;
 
-Bool            dmxAddRemoveScreens = FALSE;
+Bool            dmxAddRemoveScreens = TRUE;
+
+int             dmxLaunchIndex = 0;
+char            *dmxLaunchVT = NULL;
+
+int             dmxNumDetached = 4;
+
+#ifdef RANDR
+int             xRROutputsPerScreen = 1;
+int             xRRCrtcsPerScreen = 1;
+#endif
+
+DMXPropTrans    *dmxPropTrans = NULL;
+int             dmxPropTransNum = 0;
+
+DMXSelectionMap *dmxSelectionMap = NULL;
+int             dmxSelectionMapNum = 0;
+
+#ifdef XV
+char            **dmxXvImageFormats = NULL;
+int             dmxXvImageFormatsNum = 0;
+#endif
+
+char            dmxDigest[64];
+
+#include <execinfo.h>
+
+static void
+dmxSigHandler (int signo)
+{
+    static Bool beenHere = FALSE;
+
+    if (!beenHere)
+    {
+	void   *array[64];
+	size_t size, i;
+	char   **strings;
+
+	ErrorF ("\nBacktrace:\n");
+
+	size    = backtrace (array, 64);
+	strings = backtrace_symbols (array, size);
+
+	for (i = 0; i < size; i++)
+	    ErrorF ("%d: %s\n", i, strings[i]);
+
+	free (strings);
+
+	ErrorF ("Caught signal %d.  Server aborting\n", signo);
+
+	CloseWellKnownConnections ();
+    }
+
+    exit (1);
+}
 
 /* dmxErrorHandler catches errors that occur when calling one of the
  * back-end servers.  Some of this code is based on _XPrintDefaultError
@@ -180,6 +245,30 @@ static int dmxErrorHandler(Display *dpy,
            ev->serial);
     dmxLog(dmxWarning, "                 Current serial number: %d\n",
            dpy->request);
+
+//    abort ();
+
+    return 0;
+}
+
+int     _dmx_jumpbuf_set = 0;
+int     _dmx_io_error = 0;
+jmp_buf _dmx_jumpbuf;
+
+static int dmxIOErrorHandler (Display *dpy)
+{
+    _dmx_io_error++;
+
+    if (!_dmx_jumpbuf_set)
+    {
+	ErrorF ("_dmx_jumpbuf not set\n");
+	abort ();
+    }
+    else
+    {
+	longjmp (_dmx_jumpbuf, 1);
+    }
+
     return 0;
 }
 
@@ -190,18 +279,125 @@ static int dmxNOPErrorHandler(Display *d
 }
 #endif
 
-Bool dmxOpenDisplay(DMXScreenInfo *dmxScreen)
+char *
+dmxMemDup (const char *data,
+	   int        dataLen)
 {
-    if (!(dmxScreen->beDisplay = XOpenDisplay(dmxScreen->name)))
+    char *d;
+
+    d = malloc (dataLen);
+    if (!d)
+	return NULL;
+
+    memcpy (d, data, dataLen);
+
+    return d;
+}
+
+DMXScreenInfo *
+dmxAddScreen(const char *name,
+	     const char *display,
+	     const char *authType,
+	     int        authTypeLen,
+	     const char *authData,
+	     int        authDataLen,
+	     int        virtualFb)
+{
+    DMXScreenInfo *dmxScreen;
+    
+    if (!(dmxScreens = realloc(dmxScreens,
+                               (dmxNumScreens+1) * sizeof(*dmxScreens))))
+        dmxLog(dmxFatal,
+               "dmxAddScreen: realloc failed for screen %d (%s)\n",
+               dmxNumScreens, name);
+
+    dmxScreen = &dmxScreens[dmxNumScreens];
+    memset(dmxScreen, 0, sizeof(*dmxScreen));
+    dmxScreen->name        = strdup (name);
+    dmxScreen->display     = strdup (display);
+    dmxScreen->index       = dmxNumScreens;
+    dmxScreen->scrnWidth   = 0;
+    dmxScreen->scrnHeight  = 0;
+    dmxScreen->rootX       = 0;
+    dmxScreen->rootY       = 0;
+    dmxScreen->stat        = dmxStatAlloc();
+    dmxScreen->authType    = dmxMemDup (authType, authTypeLen);
+    dmxScreen->authTypeLen = authTypeLen;
+    dmxScreen->authData    = dmxMemDup (authData, authDataLen);
+    dmxScreen->authDataLen = authDataLen;
+    dmxScreen->virtualFb   = virtualFb;
+    ++dmxNumScreens;
+
+    return dmxScreen;
+}
+
+Bool dmxOpenDisplay(DMXScreenInfo *dmxScreen,
+		    const char    *display,
+		    const char    *authType,
+		    int           authTypeLen,
+		    const char    *authData,
+		    int           authDataLen)
+{
+    dmxScreen->beDisplay = NULL;
+
+    if (!display || !*display)
 	return FALSE;
 
-    dmxPropertyDisplay(dmxScreen);
+    if (authType && *authType)
+	XSetAuthorization ((char *) authType, authTypeLen,
+			   (char *) authData, authDataLen);
+
+    dmxScreen->alive = 1;
+
+    XLIB_PROLOGUE (dmxScreen);
+    dmxScreen->beDisplay = XOpenDisplay (display);
+    XLIB_EPILOGUE (dmxScreen);
+
+    if (!dmxScreen->beDisplay)
+    {
+        dmxScreen->alive = 0;	
+	return FALSE;
+    }
+
+    dmxScreen->alive      = 1;
+    dmxScreen->broken     = 0;
+    dmxScreen->inDispatch = FALSE;
+    dmxScreen->fd         = XConnectionNumber (dmxScreen->beDisplay);
+    dmxScreen->connection = XGetXCBConnection (dmxScreen->beDisplay);
+
+    XSetEventQueueOwner (dmxScreen->beDisplay, XCBOwnsEventQueue);
+
+    dmxScreen->sync.sequence = 0;
+
+    AddEnabledDevice (dmxScreen->fd);
+
+    dmxScreen->atomTable     = NULL;
+    dmxScreen->atomTableSize = 0;
+
+    dmxScreen->beAtomTable     = NULL;
+    dmxScreen->beAtomTableSize = 0;
+
     return TRUE;
 }
 
+void dmxCloseDisplay(DMXScreenInfo *dmxScreen)
+{
+    RemoveEnabledDevice (dmxScreen->fd);
+
+    if (dmxScreen->atomTable)
+	xfree (dmxScreen->atomTable);
+    if (dmxScreen->beAtomTable)
+	xfree (dmxScreen->beAtomTable);
+
+    xcb_disconnect (dmxScreen->connection);
+
+    dmxScreen->alive = 0;
+}
+
 void dmxSetErrorHandler(DMXScreenInfo *dmxScreen)
 {
     XSetErrorHandler(dmxErrorHandler);
+    XSetIOErrorHandler(dmxIOErrorHandler);
 }
 
 static void dmxPrintScreenInfo(DMXScreenInfo *dmxScreen)
@@ -269,14 +465,6 @@ static void dmxPrintScreenInfo(DMXScreen
                  (DoesBackingStore (s) == NotUseful) ? "no" :
                  ((DoesBackingStore (s) == Always) ? "yes" : "when mapped"),
                  DoesSaveUnders (s) ? "yes" : "no");
-    dmxLogOutput(dmxScreen, "Window Manager running: %s\n",
-		 (dmxScreen->WMRunningOnBE) ? "yes" : "no");
-
-    if (dmxScreen->WMRunningOnBE) {
-	dmxLogOutputWarning(dmxScreen,
-			    "Window manager running "
-			    "-- colormaps not supported\n");
-    }
     XFree(depths);
 }
 
@@ -292,41 +480,10 @@ void dmxGetScreenAttribs(DMXScreenInfo *
 
     dmxScreen->beWidth  = attribs.width;
     dmxScreen->beHeight = attribs.height;
-    
-                                /* Fill in missing geometry information */
-    if (dmxScreen->scrnXSign < 0) {
-        if (dmxScreen->scrnWidth) {
-            dmxScreen->scrnX   = (attribs.width - dmxScreen->scrnWidth
-				  - dmxScreen->scrnX);
-        } else {
-            dmxScreen->scrnWidth  = attribs.width - dmxScreen->scrnX;
-            dmxScreen->scrnX   = 0;
-        }
-    }
-    if (dmxScreen->scrnYSign < 0) {
-        if (dmxScreen->scrnHeight) {
-            dmxScreen->scrnY   = (attribs.height - dmxScreen->scrnHeight
-				  - dmxScreen->scrnY);
-        } else {
-            dmxScreen->scrnHeight = attribs.height - dmxScreen->scrnY;
-            dmxScreen->scrnY   = 0;
-        }
-    }
-    if (!dmxScreen->scrnWidth)
-        dmxScreen->scrnWidth  = attribs.width  - dmxScreen->scrnX;
-    if (!dmxScreen->scrnHeight)
-        dmxScreen->scrnHeight = attribs.height - dmxScreen->scrnY;
-
-    if (!dmxScreen->rootWidth)  dmxScreen->rootWidth  = dmxScreen->scrnWidth;
-    if (!dmxScreen->rootHeight) dmxScreen->rootHeight = dmxScreen->scrnHeight;
-    if (dmxScreen->rootWidth + dmxScreen->rootX > dmxScreen->scrnWidth)
-        dmxScreen->rootWidth = dmxScreen->scrnWidth - dmxScreen->rootX;
-    if (dmxScreen->rootHeight + dmxScreen->rootY > dmxScreen->scrnHeight)
-        dmxScreen->rootHeight = dmxScreen->scrnHeight - dmxScreen->rootY;
 
     /* FIXME: Get these from the back-end server */
-    dmxScreen->beXDPI = 75;
-    dmxScreen->beYDPI = 75;
+    dmxScreen->beXDPI = 96;
+    dmxScreen->beYDPI = 96;
 
     dmxScreen->beDepth  = attribs.depth; /* FIXME: verify that this
 					  * works always.  In
@@ -340,6 +497,12 @@ void dmxGetScreenAttribs(DMXScreenInfo *
     else if (dmxScreen->beDepth <= 16) dmxScreen->beBPP = 16;
     else                               dmxScreen->beBPP = 32;
 
+    if (dmxScreen->scrnWin != DefaultRootWindow(dpy))
+        XGetWindowAttributes(dpy, dmxScreen->scrnWin, &attribs);
+    
+    dmxScreen->scrnWidth  = attribs.width;
+    dmxScreen->scrnHeight = attribs.height;
+
 #ifdef GLXEXT
     /* get the majorOpcode for the back-end GLX extension */
     XQueryExtension(dpy, "GLX", &dmxScreen->glxMajorOpcode,
@@ -347,9 +510,8 @@ void dmxGetScreenAttribs(DMXScreenInfo *
 #endif
 
     dmxPrintScreenInfo(dmxScreen);
-    dmxLogOutput(dmxScreen, "%dx%d+%d+%d on %dx%d at depth=%d, bpp=%d\n",
+    dmxLogOutput(dmxScreen, "%dx%d on %dx%d at depth=%d, bpp=%d\n",
                  dmxScreen->scrnWidth, dmxScreen->scrnHeight,
-                 dmxScreen->scrnX, dmxScreen->scrnY,
                  dmxScreen->beWidth, dmxScreen->beHeight,
                  dmxScreen->beDepth, dmxScreen->beBPP);
     if (dmxScreen->beDepth == 8)
@@ -471,38 +633,70 @@ static Bool dmxSetPixmapFormats(ScreenIn
     return TRUE;
 }
 
-void dmxCheckForWM(DMXScreenInfo *dmxScreen)
-{
-    Status status;
-    XWindowAttributes xwa;
-
-    status = XGetWindowAttributes(dmxScreen->beDisplay,
-				  DefaultRootWindow(dmxScreen->beDisplay),
-				  &xwa);
-    dmxScreen->WMRunningOnBE =
-	(status &&
-	 ((xwa.all_event_masks & SubstructureRedirectMask) ||
-	  (xwa.all_event_masks & SubstructureNotifyMask)));
-}
-
 /** Initialize the display and collect relevant information about the
  *  display properties */
-static void dmxDisplayInit(DMXScreenInfo *dmxScreen)
+static Bool dmxDisplayInit(DMXScreenInfo *dmxScreen)
 {
-    if (!dmxOpenDisplay(dmxScreen))
-	dmxLog(dmxFatal,
-               "dmxOpenDisplay: Unable to open display %s\n",
-               dmxScreen->name);
-
-    dmxSetErrorHandler(dmxScreen);
-    dmxCheckForWM(dmxScreen);
-    dmxGetScreenAttribs(dmxScreen);
+    if (!dmxOpenDisplay(dmxScreen,
+			dmxScreen->display,
+			dmxScreen->authType,
+			dmxScreen->authTypeLen,
+			dmxScreen->authData,
+			dmxScreen->authDataLen))
+    {
+	if (dmxScreen->display && *dmxScreen->display)
+	    dmxLog(dmxWarning,
+		   "dmxOpenDisplay: Unable to open display %s\n",
+		   dmxScreen->display);
+
+	dmxScreen->scrnWidth  = 1;
+	dmxScreen->scrnHeight = 1;
+
+#ifdef PANORAMIX
+	if (!noPanoramiXExtension)
+	{
+	    dmxScreen->scrnWidth  = dmxScreens[0].scrnWidth;
+	    dmxScreen->scrnHeight = dmxScreens[0].scrnHeight;
+	}
+#endif
+
+	dmxScreen->beWidth    = 1;
+	dmxScreen->beHeight   = 1;
+	dmxScreen->beXDPI     = 96;
+	dmxScreen->beYDPI     = 96;
+	dmxScreen->beDepth    = 24;
+	dmxScreen->beBPP      = 32;
 
-    if (!dmxGetVisualInfo(dmxScreen))
-	dmxLog(dmxFatal, "dmxGetVisualInfo: No matching visuals found\n");
+	return FALSE;
+    }
+    else
+    {
+	if (!dmxScreen->scrnWin)
+	    dmxScreen->scrnWin = DefaultRootWindow (dmxScreen->beDisplay);
+	    
+	dmxSetErrorHandler(dmxScreen);
+	dmxGetScreenAttribs(dmxScreen);
+
+	if (!dmxGetVisualInfo(dmxScreen))
+	{
+	    dmxLog(dmxWarning,
+		   "dmxGetVisualInfo: No matching visuals found\n");
+
+	    XLIB_PROLOGUE (dmxScreen);
+	    XCloseDisplay(dmxScreen->beDisplay);
+	    XLIB_EPILOGUE (dmxScreen);
+	    dmxScreen->beDisplay = NULL;
+
+	    return FALSE;
+	}
+	else
+	{
+	    dmxGetColormaps(dmxScreen);
+	    dmxGetPixmapFormats(dmxScreen);
+	}
+    }
 
-    dmxGetColormaps(dmxScreen);
-    dmxGetPixmapFormats(dmxScreen);
+    return TRUE;
 }
 
 /* If this doesn't compile, just add || defined(yoursystem) to the line
@@ -558,7 +752,7 @@ static const char *dmxExecHost(void)
 /** This routine is called in Xserver/dix/main.c from \a main(). */
 void InitOutput(ScreenInfo *pScreenInfo, int argc, char *argv[])
 {
-    int                  i;
+    int                  i, nDetached;
     static unsigned long dmxGeneration = 0;
 #ifdef GLXEXT
     Bool                 glxSupported  = TRUE;
@@ -567,6 +761,37 @@ void InitOutput(ScreenInfo *pScreenInfo,
     if (dmxGeneration != serverGeneration) {
 	int vendrel = VENDOR_RELEASE;
         int major, minor, year, month, day;
+	unsigned char sha1[20];
+	const char *host = dmxExecHost ();
+	time_t t = time (NULL);
+	pid_t pid = getpid ();
+
+#ifdef HAVE_SHA1_IN_LIBMD /* Use libmd for SHA1 */
+	SHA1_CTX ctx;
+
+	SHA1Init (&ctx);
+	SHA1Update (&ctx, display, strlen (display));
+	SHA1Update (&ctx, host, strlen (host));
+	SHA1Update (&ctx, &t, sizeof (time_t));
+	SHA1Update (&ctx, &pid, sizeof (pid_t));
+	SHA1Final (sha1, &ctx);
+#else /* Use OpenSSL's libcrypto */
+	SHA_CTX ctx;
+
+	if (!SHA1_Init (&ctx)                              ||
+	    !SHA1_Update (&ctx, display, strlen (display)) ||
+	    !SHA1_Update (&ctx, host, strlen (host))       ||
+	    !SHA1_Update (&ctx, &t, sizeof (time_t))       ||
+	    !SHA1_Update (&ctx, &pid, sizeof (pid_t))      ||
+	    !SHA1_Final (sha1, &ctx))
+	{
+	    dmxLog(dmxFatal, "SHA1_Init failed\n");
+	}
+#endif
+
+	for (i = 0; i < sizeof (sha1); i++)
+	    snprintf(dmxDigest + 2 * i, sizeof (dmxDigest) - 2 * i, "%02x",
+		     sha1[i]);
         
         dmxGeneration = serverGeneration;
 
@@ -584,6 +809,7 @@ void InitOutput(ScreenInfo *pScreenInfo,
         if (major > 0 && minor > 0) year += 2000;
 
         dmxLog(dmxInfo, "Generation:         %d\n", dmxGeneration);
+	dmxLog(dmxInfo, "DMX digest:         %s\n", dmxDigest);
         dmxLog(dmxInfo, "DMX version:        %d.%d.%02d%02d%02d (%s)\n",
                major, minor, year, month, day, VENDOR_STRING);
 
@@ -601,17 +827,13 @@ void InitOutput(ScreenInfo *pScreenInfo,
         for (i = 0; i < dmxNumScreens; i++) {
             if (dmxScreens[i].beDisplay)
                 dmxLog(dmxWarning, "Display \"%s\" still open\n",
-                       dmxScreens[i].name);
+                       dmxScreens[i].display);
             dmxStatFree(dmxScreens[i].stat);
             dmxScreens[i].stat = NULL;
         }
-        for (i = 0; i < dmxNumInputs; i++) dmxInputFree(&dmxInputs[i]);
         if (dmxScreens) free(dmxScreens);
-        if (dmxInputs)  free(dmxInputs);
         dmxScreens    = NULL;
-        dmxInputs     = NULL;
         dmxNumScreens = 0;
-        dmxNumInputs  = 0;
     }
 
     /* Make sure that the command-line arguments are sane. */
@@ -633,14 +855,49 @@ void InitOutput(ScreenInfo *pScreenInfo,
 	       "Dynamic screen addition/removal error (see above).\n");
     }
 
-    /* ddxProcessArgument has been called at this point, but any data
-     * from the configuration file has not been applied.  Do so, and be
-     * sure we have at least one back-end display. */
-    dmxConfigConfigure();
+    for (i = 0; i < dmxPropTransNum; i++)
+	dmxPropTrans[i].type = MakeAtom ((char *) dmxPropTrans[i].name,
+					 strlen (dmxPropTrans[i].name),
+					 TRUE);
+
+    for (i = 0; i < dmxSelectionMapNum; i++)
+    {
+	char *beName;
+
+	dmxSelectionMap[i].atom = MakeAtom ((char *) dmxSelectionMap[i].name,
+					    strlen (dmxSelectionMap[i].name),
+					    TRUE);
+
+	beName = xalloc (strlen (dmxSelectionMap[i].name) +
+			 strlen (dmxDigest) + 2);
+	if (!beName)
+	    dmxLog (dmxFatal, "InitOutput: not enough memory\n");
+	
+	sprintf (beName, "%s_%s", dmxSelectionMap[i].name, dmxDigest);
+	dmxSelectionMap[i].beAtom = MakeAtom ((char *) beName,
+					      strlen (beName),
+					      TRUE);
+	xfree (beName);
+    }
+
     if (!dmxNumScreens)
-        dmxLog(dmxFatal, "InitOutput: no back-end displays found\n");
-    if (!dmxNumInputs)
-        dmxLog(dmxInfo, "InitOutput: no inputs found\n");
+    {
+	dmxLaunchDisplay (argc, argv, dmxLaunchIndex, dmxLaunchVT);
+	if (!dmxNumScreens)
+	    dmxLog(dmxFatal, "InitOutput: no back-end displays found\n");
+    }
+
+    nDetached = dmxNumDetached;
+    if (dmxNumScreens + nDetached > MAXSCREENS)
+	nDetached = MAXSCREENS - dmxNumScreens;
+    
+    if (nDetached > 0)
+    {
+	dmxLog (dmxInfo, "Adding %d detached displays\n", nDetached);
+
+	while (nDetached--)
+	    dmxAddScreen ("", "", NULL, 0, NULL, 0, 0);
+    }
     
     /* Disable lazy window creation optimization if offscreen
      * optimization is disabled */
@@ -656,7 +913,10 @@ void InitOutput(ScreenInfo *pScreenInfo,
 
     /* Open each display and gather information about it. */
     for (i = 0; i < dmxNumScreens; i++)
-        dmxDisplayInit(&dmxScreens[i]);
+	if (!dmxDisplayInit(&dmxScreens[i]) && i == 0)
+	    dmxLog(dmxFatal,
+		   "dmxOpenDisplay: Unable to open display %s\n",
+		   dmxScreens[i].display);
 
 #if PANORAMIX
     /* Register a Xinerama callback which will run from within
@@ -682,7 +942,11 @@ void InitOutput(ScreenInfo *pScreenInfo,
      * same as the behavior of SIGINT.  However, leaving the modifier
      * map of the input devices empty is even more unexpected.) --RF
      */
-    OsSignal(SIGQUIT, GiveUp);
+    OsSignal (SIGQUIT, GiveUp);
+    OsSignal (SIGSEGV, dmxSigHandler);
+    OsSignal (SIGILL,  dmxSigHandler);
+    OsSignal (SIGFPE,  dmxSigHandler);
+    OsSignal (SIGABRT, dmxSigHandler);
 
 #ifdef GLXEXT
     /* Check if GLX extension exists on all back-end servers */
@@ -779,19 +1043,17 @@ void InitOutput(ScreenInfo *pScreenInfo,
 	AddScreen(dmxScreenInit, argc, argv);
     }
 
-    /* Compute origin information. */
-    dmxInitOrigins();
-
-    /* Compute overlap information. */
-    dmxInitOverlap();
-
     /* Make sure there is a global width/height available */
-    dmxComputeWidthHeight(DMX_NO_RECOMPUTE_BOUNDING_BOX);
+    dmxComputeWidthHeight ();
 
-    /* FIXME: The following is temporarily placed here.  When the DMX
-     * extension is available, it will be move there.
-     */
-    dmxInitFonts();
+    dmxInitProps();
+    dmxInitGrabs();
+    dmxInitSelections();
+    dmxInitInput ();
+
+#ifdef MITSHM
+    dmxInitShm();
+#endif
 
 #ifdef RENDER
     /* Initialize the render extension */
@@ -799,12 +1061,19 @@ void InitOutput(ScreenInfo *pScreenInfo,
 	dmxInitRender();
 #endif
 
+#ifdef COMPOSITE
+    /* Initialize the composite extension */
+    if (!noCompositeExtension)
+	dmxInitComposite();
+#endif
+
     /* Initialized things that need timer hooks */
     dmxStatInit();
     dmxSyncInit();              /* Calls RegisterBlockAndWakeupHandlers */
 
-    dmxLog(dmxInfo, "Shadow framebuffer support %s\n",
-	   dmxShadowFB ? "enabled" : "disabled");
+    for (i = 0; i < dmxNumScreens; i++)
+	if (dmxScreens[i].beDisplay)
+	    dmxBEScreenInit (screenInfo.screens[i]);
 }
 
 /* RATS: Assuming the fp string (which comes from the command-line argv
@@ -842,6 +1111,8 @@ void AbortDDX(void)
         if (dmxScreen->beDisplay) XCloseDisplay(dmxScreen->beDisplay);
         dmxScreen->beDisplay = NULL;
     }
+
+    dmxAbortDisplay ();
 }
 
 /** This function is called in Xserver/dix/main.c from \a main() when
@@ -852,9 +1123,73 @@ void ddxGiveUp(void)
     AbortDDX();
 }
 
+#ifdef PANORAMIX
+static Bool dmxNoPanoramiXExtension = FALSE;
+#endif
+
 /** This function is called in Xserver/os/osinit.c from \a OsInit(). */
 void OsVendorInit(void)
 {
+    if (!dmxPropTrans)
+    {
+	dmxPropTrans = xalloc (sizeof (DMXPropTrans) * 2);
+	dmxPropTrans[0].name = "ATOM_PAIR";
+	dmxPropTrans[0].format = "aa..";
+	dmxPropTrans[0].type = 0;
+	dmxPropTrans[1].name = "_COMPIZ_WINDOW_DECOR";
+	dmxPropTrans[1].format = "xP";
+	dmxPropTrans[1].type = 0;
+	dmxPropTransNum = 2;
+    }
+
+    if (!dmxSelectionMap)
+    {
+	dmxSelectionMap = xalloc (sizeof (DMXSelectionMap) * 9);
+	dmxSelectionMap[0].name = "WM_S0";
+	dmxSelectionMap[0].atom = 0;
+	dmxSelectionMap[0].beAtom = 0;
+	dmxSelectionMap[1].name = "_NET_WM_CM_S0";
+	dmxSelectionMap[1].atom = 0;
+	dmxSelectionMap[1].beAtom = 0;
+	dmxSelectionMap[2].name = "_NET_SYSTEM_TRAY_S0";
+	dmxSelectionMap[2].atom = 0;
+	dmxSelectionMap[2].beAtom = 0;
+	dmxSelectionMap[3].name = "_NET_DESKTOP_LAYOUT_S0";
+	dmxSelectionMap[3].atom = 0;
+	dmxSelectionMap[3].beAtom = 0;
+	dmxSelectionMap[4].name = "_NET_DESKTOP_MANAGER_S0";
+	dmxSelectionMap[4].atom = 0;
+	dmxSelectionMap[4].beAtom = 0;
+	dmxSelectionMap[5].name = "_XSETTINGS_S0";
+	dmxSelectionMap[5].atom = 0;
+	dmxSelectionMap[5].beAtom = 0;
+	dmxSelectionMap[6].name = "CLIPBOARD_MANAGER";
+	dmxSelectionMap[6].atom = 0;
+	dmxSelectionMap[6].beAtom = 0;
+	dmxSelectionMap[7].name = "GVM_SELECTION";
+	dmxSelectionMap[7].atom = 0;
+	dmxSelectionMap[7].beAtom = 0;
+	dmxSelectionMap[8].name = "_COMPIZ_DM_S0";
+	dmxSelectionMap[8].atom = 0;
+	dmxSelectionMap[8].beAtom = 0;
+	dmxSelectionMapNum = 9;
+    }
+
+#ifdef PANORAMIX
+    noPanoramiXExtension = dmxNoPanoramiXExtension;
+    PanoramiXExtensionDisabledHack = TRUE;
+#endif
+
+#ifdef XV
+    if (!dmxXvImageFormats)
+    {
+	dmxXvImageFormats = xalloc (sizeof (char *) * 2);
+	dmxXvImageFormats[0] = "YV12";
+	dmxXvImageFormats[1] = "YUY2";
+	dmxXvImageFormatsNum = 2;
+    }
+#endif
+
 }
 
 /** This function is called in Xserver/os/utils.c from \a FatalError()
@@ -870,33 +1205,12 @@ void OsVendorFatalError(void)
 int ddxProcessArgument(int argc, char *argv[], int i)
 {
     int retval = 0;
-    
+
     if (!strcmp(argv[i], "-display")) {
-	if (++i < argc) dmxConfigStoreDisplay(argv[i]);
+	if (++i < argc) dmxAddScreen(argv[i], argv[i], NULL, 0, NULL, 0, 0);
         retval = 2;
-    } else if (!strcmp(argv[i], "-inputfrom") || !strcmp(argv[i], "-input")) {
-	if (++i < argc) dmxConfigStoreInput(argv[i]);
-        retval = 2;
-    } else if (!strcmp(argv[i], "-xinputfrom") || !strcmp(argv[i],"-xinput")) {
-        if (++i < argc) dmxConfigStoreXInput(argv[i]);
-        retval = 2;
-    } else if (!strcmp(argv[i], "-noshadowfb")) {
-        dmxLog(dmxWarning,
-               "-noshadowfb has been deprecated "
-	       "since it is now the default\n");
-	dmxShadowFB = FALSE;
-	retval = 1;
-    } else if (!strcmp(argv[i], "-nomulticursor")) {
-        dmxCursorNoMulti();
-	retval = 1;
-    } else if (!strcmp(argv[i], "-shadowfb")) {
-	dmxShadowFB = TRUE;
-	retval = 1;
-    } else if (!strcmp(argv[i], "-configfile")) {
-        if (++i < argc) dmxConfigStoreFile(argv[i]);
-        retval = 2;
-    } else if (!strcmp(argv[i], "-config")) {
-        if (++i < argc) dmxConfigStoreConfig(argv[i]);
+    } else if (!strcmp(argv[i], "-numDetached")) {
+	if (++i < argc) dmxNumDetached = atoi (argv[i]);
         retval = 2;
     } else if (!strcmp(argv[i], "-fontpath")) {
         if (++i < argc) dmxSetDefaultFontPath(argv[i]);
@@ -907,14 +1221,14 @@ int ddxProcessArgument(int argc, char *a
     } else if (!strcmp(argv[i], "-syncbatch")) {
         if (++i < argc) dmxSyncActivate(argv[i]);
         retval = 2;
-    } else if (!strcmp(argv[i], "-nooffscreenopt")) {
-	dmxOffScreenOpt = FALSE;
+    } else if (!strcmp(argv[i], "-offscreenopt")) {
+	dmxOffScreenOpt = TRUE;
         retval = 1;
     } else if (!strcmp(argv[i], "-nosubdivprims")) {
 	dmxSubdividePrimitives = FALSE;
         retval = 1;
-    } else if (!strcmp(argv[i], "-nowindowopt")) {
-	dmxLazyWindowCreation = FALSE;
+    } else if (!strcmp(argv[i], "-windowopt")) {
+	dmxLazyWindowCreation = TRUE;
         retval = 1;
     } else if (!strcmp(argv[i], "-noxkb")) {
 	dmxUseXKB = FALSE;
@@ -942,29 +1256,94 @@ int ddxProcessArgument(int argc, char *a
     } else if (!strcmp(argv[i], "-ignorebadfontpaths")) {
 	dmxIgnoreBadFontPaths = TRUE;
         retval = 1;
-    } else if (!strcmp(argv[i], "-addremovescreens")) {
-	dmxAddRemoveScreens = TRUE;
+    } else if (!strcmp(argv[i], "-noaddremovescreens")) {
+	dmxAddRemoveScreens = FALSE;
         retval = 1;
-    } else if (!strcmp(argv[i], "-param")) {
-        if ((i += 2) < argc) {
-            if (!strcasecmp(argv[i-1], "xkbrules"))
-                dmxConfigSetXkbRules(argv[i]);
-            else if (!strcasecmp(argv[i-1], "xkbmodel"))
-                dmxConfigSetXkbModel(argv[i]);
-            else if (!strcasecmp(argv[i-1], "xkblayout"))
-                dmxConfigSetXkbLayout(argv[i]);
-            else if (!strcasecmp(argv[i-1], "xkbvariant"))
-                dmxConfigSetXkbVariant(argv[i]);
-            else if (!strcasecmp(argv[i-1], "xkboptions"))
-                dmxConfigSetXkbOptions(argv[i]);
-            else
-                dmxLog(dmxWarning,
-                       "-param requires: XkbRules, XkbModel, XkbLayout,"
-                       " XkbVariant, or XkbOptions\n");
-        }
+#ifdef PANORAMIX
+    } else if (!strcmp (argv[i], "-xinerama")) {
+	dmxNoPanoramiXExtension = TRUE;
+	retval = 1;
+#endif
+#ifdef RANDR
+    } else if (!strcmp(argv[i], "-outputs")) {
+	if (++i < argc) xRROutputsPerScreen = atoi(argv[i]);
+        retval = 2;
+    } else if (!strcmp(argv[i], "-crtcs")) {
+	if (++i < argc) xRRCrtcsPerScreen = atoi(argv[i]);
+        retval = 2;
+    }
+#endif
+    else if (!strcmp (argv[i], "-prop"))
+    {
+	if ((i + 2) < argc)
+	{
+	    DMXPropTrans *prop;
+
+	    prop = xrealloc (dmxPropTrans, sizeof (DMXPropTrans) *
+			     (dmxPropTransNum + 1));
+	    if (prop)
+	    {
+		prop[dmxPropTransNum].name   = argv[i + 1];
+		prop[dmxPropTransNum].format = argv[i + 2];
+		prop[dmxPropTransNum].type   = 0;
+
+		dmxPropTransNum++;
+		dmxPropTrans = prop;
+	    }
+	}
         retval = 3;
     }
-    if (!serverGeneration) dmxConfigSetMaxScreens();
+    else if (!strcmp (argv[i], "-selection"))
+    {
+	if (++i < argc)
+	{
+	    DMXSelectionMap *selection;
+
+	    selection = xrealloc (dmxSelectionMap, sizeof (DMXSelectionMap) *
+				  (dmxSelectionMapNum + 1));
+	    if (selection)
+	    {
+		selection[dmxSelectionMapNum].name   = argv[i];
+		selection[dmxSelectionMapNum].atom   = 0;
+		selection[dmxSelectionMapNum].beAtom = 0;
+
+		dmxSelectionMapNum++;
+		dmxSelectionMap = selection;
+	    }
+	}
+        retval = 2;
+    }
+#ifdef XV
+    else if (!strcmp (argv[i], "-xvimage"))
+    {
+	if (++i < argc)
+	{
+	    char **formats;
+
+	    formats = xrealloc (dmxXvImageFormats,
+				sizeof (char *) *
+				(dmxXvImageFormatsNum + 1));
+	    if (formats)
+	    {
+		formats[dmxXvImageFormatsNum] = argv[i];
+
+		dmxXvImageFormatsNum++;
+		dmxXvImageFormats = formats;
+	    }
+	}
+        retval = 2;
+    }
+#endif
+    else if ((argv[i][0] == 'v') && (argv[i][1] == 't'))
+    {
+        dmxLaunchVT = argv[i];
+	retval = 1;
+    }
+    else if (!strcmp(argv[i], "--")) {
+        dmxLaunchIndex = i + 1;
+        retval = argc - i;
+    }
+
     return retval;
 }
 
